//package wPercept;

import java.io.*;

public class ConnectionInformation implements Serializable
{
	private String message;
	private String robotIP;
	private int robotPort;
	private int clientID;

	public ConnectionInformation()
	{
		message = robotIP = null;
		robotPort = 0;
		clientID = -1;
	}

	public void setMsg(String s)
	{
		message = s;
	}
	public String getMsg() { return message; }

	public void setRobotIP_Port(String ip, int port)
	{
		robotIP = new String(ip);
		robotPort = port;
	}

	public String getRobotIP() { return robotIP; }
	public int    getRobotPort() { return robotPort; }

	public void setClientID(int c)
	{
		clientID = c;
	}

	public int getClientID()  { return clientID; }

	public String toString()
	{
		return message + ", " + robotIP + ", Port = "+ robotPort + ", Client# = " + clientID;
	}

}