/***************************************************************************
Programmer: Srinath Sridhar
Project Wise
- Receives the Frames sent by WiseSnapServer
- Uses Image Viewer to display the frames
***************************************************************************/

import java.io.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;


class Receive extends Frame {
    transient Image im1;
    transient Object buffo= null;
    transient Dimension buffd=null;
    transient MemoryImageSource mis=null;
    InputStream is;
    ObjectInputStream ois;
    ObjectOutputStream oos;
    ImageViewer iv;
    int portno;
	G_Client g_client;
	G_Client.OnDemandDlg od;

    Receive(ObjectInputStream istemp,ObjectOutputStream ostemp, int port) {
        ois = istemp;
        oos = ostemp;
		od = null;
        portno = port;
        iv = new ImageViewer(portno);
        try {
        //    Thread.sleep(1000);
        }
        catch(Exception e){}
        System.out.println("Exiting from the Receive Constructor");
    }

	Receive(ObjectInputStream istemp,ObjectOutputStream ostemp, int port, G_Client.OnDemandDlg onDmd) {
        ois = istemp;
        oos = ostemp;
		od = onDmd;
        portno = port;
        iv = new ImageViewer(portno);
        try {
        //    Thread.sleep(1000);
        }
        catch(Exception e){}
        System.out.println("Exiting from the Receive Constructor");
    }
    void setG_Client(G_Client g)
    {
		g_client = g;
	}
    void getOneFrame() {
        try {
            iv.imageViewer2p();
            String msg = (String)ois.readObject();
            if(msg.equals("Close"))
            {
				JOptionPane.showMessageDialog(null,"Oops!! Connection closed, Avataar can not send image percepts");

				if(g_client!=null && od == null)
				 g_client.closeImageConnection();
				else
				 if(od!=null)
				 {
				  //closeReception();
					try
					{
						oos.close();
						ois.close();
					}
					catch(IOException ioe)
					{
					}
				  iv.closeWindow();
				  od.closeWindow();
			   	 }
				return;
			}
            buffd = (Dimension) ois.readObject();

            buffo = ois.readObject();
            int [] pixs = (int []) buffo;
            mis = new MemoryImageSource((int)buffd.getWidth(), (int)buffd.getHeight(), pixs, 0, (int)buffd.getWidth());
            im1 = createImage(mis);
            iv.showImage(im1);
            buffd = null;
            buffo = null;
            mis = null;
            im1 = null;
            System.gc();
            System.gc();
            System.gc();
            System.gc();
        }   catch(Exception e) { System.err.println("Exception");}
    }

    void closeReception()
    {
		try
		{
			System.out.println("Closing reception");
			oos.writeObject("Closing Connection");
			oos.close();

			ois.close();

			iv.closeWindow();
		}
		catch(IOException e)
		{
		}
	}

}
