/****************************************************************************
Programmer: Srinath Sridhar
Project Wise
- startReception method is called to instantiate an object of Receive class
- This Thread is used to get one frame from each of the port
- Yields to threads that check for activity on other ports
***************************************************************************/

import java.io.*;

class ThreadControl implements Runnable {

    private boolean go;
    public static Receive receive;
    static ObjectInputStream ois1=null;
    Thread t;
    ThreadControl() {
	   go = true;
       t = new Thread(this);
       t.start();
    }

    public static void startReception(ObjectInputStream ois,ObjectOutputStream oos, int portno) {
        ois1=ois;
        System.out.println("In ThreadControl.startReception()");
                receive = new Receive(ois,oos, portno);
        System.out.println("Exiting from ThreadControl.startReception()");
    }

    public void run() {
        while(go) {

                if(receive != null)  {
                      receive.getOneFrame();
                }
            t.yield();
        }
        System.out.println("Stopped Running");
   }

   public void stopThread()
   {
	   go = false;
   }

}

