import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.image.*;
import java.util.*;
import java.io.*;
import java.awt.geom.*;
public class ClientDisplay extends JFrame
{
	private GeneralPath path;
	private Vector[] vPoints;
	private Vector[] vObstacles;
	private int nValidPolygons;
	private int nInvalidPolygons;
	private GeneralPath[] validPath;
	private GeneralPath[] invalidPath;
	private int nWidth;
	private int nHeight;
	private ClientDisplayPanel cdp;
	private JLabel statusBar;
	private String facingDirection;
	private JButton defLocBtn;
	private int     orientation;
	public ClientDisplay()
	{
		super("Plan of II Floor, Nedderman Hall, UTA");
		statusBar = new JLabel();
		defLocBtn = new JButton("Specify Default Start Location");
		cdp = new ClientDisplayPanel(statusBar);

		defLocBtn.addActionListener(
			new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(cdp.getStartLoc()==null)
 						cdp.setCrossHairCursor();
 					else
 						cdp.setDefaultCursor();

				}
			}
			);

	    JScrollPane scroller = new JScrollPane(cdp);
	    scroller.setPreferredSize(new Dimension(633,633));
		JPanel mainPanel = new JPanel();
		mainPanel.setLayout(new BorderLayout());

		mainPanel.add(defLocBtn,BorderLayout.NORTH);
		mainPanel.add(statusBar, BorderLayout.SOUTH);
		mainPanel.add(scroller, BorderLayout.CENTER);

		setContentPane(mainPanel);
		setSize(800,800);

	}

    public void setStartLoc(Cell_Client x)
    {
		cdp.setStartLoc(x);
	}

	public Cell_Client getStartLoc()
	{
		return cdp.getStartLoc();
	}
    public void setStateBtn(boolean x)
    {
		defLocBtn.setEnabled(x);

	}
	public void setFacing(String f)
	{

	}

	public void setCurrentLocation(Cell_Client cc)
	{
		cdp.setCurrentLocation(cc);
	}
	public void setOrientation(int o)
	{
		cdp.setOrientation(o);
	}
	public int getOrientation()
	{
		return cdp.getOrientation();
	}

	public int getOrgOrientation()
	{
		return cdp.getOrgOrientation();
	}
	public void paint(Graphics g)
	{
			super.paint(g);
			cdp.setPreferredSize(new Dimension(633,633));
			cdp.scrollRectToVisible(new Rectangle(0,0,633,633));
			cdp.revalidate();
			cdp.draw();

	}

}