import javax.swing.*;
import java.awt.*;

import java.awt.event.*;

public class GetOrientation extends JDialog
{
	private JRadioButton north;
	private JRadioButton east;
	private JRadioButton south;
	private JRadioButton west;
	private JButton      closeBtn;
	private int orientation;
	public GetOrientation(JFrame frame,boolean modal)
	{
		super(frame, modal);
		setTitle("Orientation");
		north = new JRadioButton("NORTH");
		east  = new JRadioButton("EAST");
		south = new JRadioButton("SOUTH");
		west  = new JRadioButton("WEST");
		ButtonGroup bg = new ButtonGroup();
		bg.add(north);
		bg.add(east);
		bg.add(south);
		bg.add(west);

		north.setSelected(true);
		closeBtn = new JButton("Close");
		getContentPane().setLayout(null);
		north.setBounds(15,10,75,20);
		east.setBounds(15,35,75,20);
		south.setBounds(15,65,75,20);
		west.setBounds(15,95,75,20);

		getContentPane().add(north);
		getContentPane().add(east);
		getContentPane().add(south);
		getContentPane().add(west);

		closeBtn.addActionListener(new Handler());
		getContentPane().add(closeBtn);

		closeBtn.setBounds(20,125,75,25);
		setSize(150,200);

		addWindowListener(
			new WindowAdapter()
			{
				public void windowClosing(WindowEvent e)
				{
					setOrientation();

					windowClose();

				}
			}
			);
	}

	private class Handler implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{

			setOrientation();
			windowClose();
		}

	}
	public void windowClose()
	{
		dispose();
	}
    public void setOrientation()
    {
		if(north.isSelected())
			orientation = 1;
		if(east.isSelected())
			orientation = 2;
		if(south.isSelected())
			orientation = 3;
		if(west.isSelected())
			orientation = 4;
	}

	public int getOrientation()
	{
		return orientation;
	}

}